Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa10w.bas
'*
'* aISA-P10
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/06/02
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA10_DLL_NAME = "aisa10.dll"  ' DLLt@C
Global Const AISA10_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ̃nh

'*****************************************************************************
'* @\     aisa10.dll[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa10wDllOpen() As Boolean

    Aisa10wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AISA10_DLL_NAME)
    
    If hDLL = 0 Then Exit Function
    
    If Aisa10wGetDllExportFunc() = False Then
        Aisa10wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    
    Aisa10wDllOpen = True

End Function

'*****************************************************************************
'* @\     aisa10.dllA[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa10wDllClose() As Boolean
    
    If hDLL = 0 Then
        Aisa10wDllClose = True
        Exit Function
    End If
    
    If FreeLibrary(hDLL) <> 0 Then
        hDLL = 0
        Aisa10wDllClose = True
        Exit Function
    End If
    
    Aisa10wDllClose = False

End Function

'*****************************************************************************
'* @\     aISA-P10 DLL,Driver̃o[Wԍ擾
'*      pdwDllVer --- DLLo[Wԍi[
'*          pdwDrvVer --- Drivero[Wԍi[
'* ߂l   True       --- 
'*          False      --- s
'*****************************************************************************
Function Aisa10wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    If hDLL = 0 Then
        Aisa10wGetVersion = 0
        Exit Function
    End If
    
    If Aisa10GetVersion(pdwDllVer, pdwDrvVer) <> 0 Then
        Aisa10wGetVersion = True
    Else
        Aisa10wGetVersion = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P10̔Cӂ̃foCX̎gp錾
'*      pwLogSlot --- gpfoCXi[AhX
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa10wCreate(pwLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa10wCreate = False
        Exit Function
    End If
    
    If Aisa10Create(pwLogSlot) <> 0 Then
        Aisa10wCreate = True
    Else
        Aisa10wCreate = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-P10̔Cӂ̃foCX̎gpJ
'*      wLogSlot --- gpfoCX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa10wClose(wLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa10wClose = False
        Exit Function
    End If
    
    If Aisa10Close(wLogSlot) <> 0 Then
        Aisa10wClose = True
    Else
        Aisa10wClose = False
    End If

End Function

'*****************************************************************************
'* @\     wfoCX̃\[X擾
'*      wLogSlot --- ׂfoCX
'*          pResInfo --- \[Xi[\̂̃AhX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa10wGetResource(wLogSlot As Integer, pResInfo As AISA10RESOURCE) As Boolean
    
    If hDLL = 0 Then
        Aisa10wGetResource = False
        Exit Function
    End If
    
    If Aisa10GetResource(wLogSlot, pResInfo) <> 0 Then
        Aisa10wGetResource = True
    Else
        Aisa10wGetResource = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gf[^
'*      wLogSlot  --- ͂foCX
'*          dwPort    --- ͂|[g
'*          pbInValue --- ̓f[^i[
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa10wInPort(wLogSlot As Integer, dwPort As Long, pbInValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa10wInPort = False
        Exit Function
    End If
    
    If Aisa10InPort(wLogSlot, dwPort, pbInValue) <> 0 Then
        Aisa10wInPort = True
    Else
        Aisa10wInPort = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gփf[^o
'*      wLogSlot  --- o͂foCX
'*          dwPort    --- o͂|[g
'*          bOutValue --- o͂f[^
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa10wOutPort(wLogSlot As Integer, dwPort As Long, bOutValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa10wOutPort = False
        Exit Function
    End If
    
    If Aisa10OutPort(wLogSlot, dwPort, bOutValue) <> 0 Then
        Aisa10wOutPort = True
    Else
        Aisa10wOutPort = False
    End If

End Function

'*****************************************************************************
'* @\      aISA-P10̃G[R[h𓾂
'*       wLogSlot --- G[foCX
'* ߂l             --- G[R[h
'*****************************************************************************
Function Aisa10wGetLastError(wLogSlot As Integer) As Long
    
    If hDLL = 0 Then
        Aisa10wGetLastError = AISA10_ERR_WRAPDLL
        Exit Function
    End If
    
    Aisa10wGetLastError = Aisa10GetLastError(wLogSlot)

End Function

'*****************************************************************************
'* @\     DLLGNX|[g֐L̊mF
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Private Function Aisa10wGetDllExportFunc() As Boolean
    
    Dim pFunc As Long
    
    Aisa10wGetDllExportFunc = False
    
    ' Aisa10GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa10GetVersion")
    If pFunc = 0 Then Exit Function
          
    ' Aisa10Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa10Create")
    If pFunc = 0 Then Exit Function
          
    ' Aisa10Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa10Close")
    If pFunc = 0 Then Exit Function

    ' Aisa10GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa10GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa10InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa10InPort")
    If pFunc = 0 Then Exit Function

    ' Aisa10OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa10OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa10GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa10GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa10wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
